<?php
// $Id: iContactAccount.class.inc,v 1.1.2.1 2009/08/17 23:33:50 greenskin Exp $

class iContactAccount extends iContactResource {
  protected $uri = '/a';
  protected $type = 'account';
  public $accountId = 0;
  public $clientFolders = array();
  public $users = array();

  protected function collapse() {
    $array = array();
    foreach ($this as $key => $value) {
      switch ($key) {
        case 'uri':
        case 'type':
        case 'iContact':
          break;
        case 'clientFolders':
        case 'users':
          $array[$key] = array();
          foreach ($value as $k => $v) {
            $array[$key][$k] = $k;
          }
          break;
        default:
          $array[$key] = $value;
          break;
      }
    }
    return $array;
  }

  protected function expand() {
    if (!empty($this->clientFolders)) {
      foreach ($this->clientFolders as $k => $v) {
        if (is_int($v)) {
          $this->clientFolders[$k] = new iContactClientFolder($this, $v);
        }
      }
    }
    if (!empty($this->users)) {
      foreach ($this->users as $k => $v) {
        if (is_int($v)) {
          $this->users[$k] = new iContactUser($this, $v);
        }
      }
    }
  }

  protected function defaults() {
    return array(
      'subscriberLimit' => 5000,
      'accountType' => 0,
      'firstName' => '',
      'lastName' => '',
      'title' => '',
      'phone' => '',
      'fax' => '',
      'email' => '',
      'companyName' => '',
      'street' => '',
      'city' => '',
      'state' => '',
      'postalCode' => '',
      'billingStreet' => '',
      'billingCity' => '',
      'billingState' => '',
      'billingPostalCode' => ''
    );
  }

  protected function setResources() {
    $this->resources = array('clientFolder' => '/a/'. $this->accountId .'/c');
  }
}
