<?php
// $Id: iContactContact.class.inc,v 1.1.2.1 2009/08/17 23:33:50 greenskin Exp $

class iContactContact extends iContactResource {
  protected $type = 'contact';
  public $accountId;
  public $clientFolderId;
  public $contactId;

  public function __construct(iContactClientFolder $clientFolder, $contact = NULL) {
    $this->accountId = $clientFolder->accountId;
    $this->clientFolderId = $clientFolder->clientFolderId;
    $this->uri = '/a/'. $this->accountId .'/c/'. $this->clientFolderId .'/contacts';

    parent::__construct($clientFolder->iContact, $contact);
  }

  protected function collapse() {
    $array = array();
    foreach ($this as $key => $value) {
      switch ($key) {
        case 'uri':
        case 'type':
        case 'iContact':
          break;
        default:
          $array[$key] = $value;
          break;
      }
    }
    return $array;
  }

  protected function expand() {
    
  }

  protected function defaults() {
    return array(
      'email' => '',
      'status' => 'normal',
      'prefix' => '',
      'firstName' => '',
      'lastName' => '',
      'suffix' => '',
      'street' => '',
      'street2' => '',
      'city' => '',
      'state' => '',
      'postalCode' => '',
      'phone' => '',
      'fax' => '',
      'business' => ''
    );
  }

  function actions($contactId = NULL) {
    if ($contactId == NULL) $contactId = $this->contactId;
    return $this->requestData('/a/'. $this->accountId .'/c/'. $this->clientFolderId .'/contacts/'. $contactId .'/actions');
  }
}
