<?php
// $Id: iContactUser.class.inc,v 1.1.2.1 2009/08/17 23:33:50 greenskin Exp $

class iContactUser extends iContactResource {
  var $account;
  var $userId;
  var $cache = FALSE;

  function __construct($account, $user = NULL) {
    $this->account = $account;
    return $this->init($user);
  }

  function __destruct() {
    if ($this->cache) {
      db_set_active();
      $this->set_cache();
    }
  }

  function set_cache() {
    if ($this->userId > 0) {
      $data = array();
      foreach ($this as $key => $value) {
        switch ($key) {
          case 'account':
          case 'cache':
            break;
          default:
            $data[$key] = $value;
            break;
        }
      }
      cache_set('user:'. $this->userId, $data, 'cache_icontact');
    }
  }

  function init($user) {
    if ($user === NULL) {
      $user = array(
        'userName' => '',
        'password' => '',
        'firstName' => '',
        'lastName' => '',
        'enabled' => 1,
        'editor' => 3
      );
    }
    if (is_integer($user)) {
      return $this->load($user);
    }
    else {
      foreach ($user as $key => $value) {
        switch ($key) {
          default:
            $this->$key = (is_object($value) && get_class($value) == 'SimpleXMLElement') ? (string)$value : $value;
            break;
        }
      }
    }
    return TRUE;
  }

  function load($userId = NULL) {
    if ($userId === NULL) $userId = $this->userId;
    if ($userId > 0) {
      if ($cache = cache_get('user:'. $userId, 'cache_icontact')) {
        return $this->init($cache->data);
      }

      $result = $this->account->icontact->requestData('/a/'. $this->account->accountId .'/users/'. $userId);
      if (!empty($result)) {
        $this->cache = TRUE;
        return $this->init($result->user->children());
      }
    }
    return FALSE;
  }

  function save($user) {
    if (is_array($user)) $user = (object)$user;

    if (isset($user->userId) && $user->userId > 0) {
      $xml_txt = '<user></user>';
      $xml_obj = simplexml_load_string($xml_txt);
      foreach ($user as $key => $value) {
        $xml_obj->addChild($key, $value);
      }
      $uri = '/a/'. $this->account->accountId .'/users/'. $user->userId;
      $data = $this->account->icontact->request($uri, 'PUT', $xml_obj->asXML());
      dpm($data);
      $data = $data->data;
      if (isset($data->warnings->warning)) {
        drupal_set_message((string)$data->warnings->warning);
        return FALSE;
      }
      $this->cache = TRUE;
      return TRUE;
    }
    else {
      $xml_txt = '<users><user></user></users>';
      $xml_obj = simplexml_load_string($xml_txt);
      foreach ($user as $key => $value) {
        $xml_obj->user->addChild($key, $value);
      }
      $uri = '/a/'. $this->account->accountId .'/users';
      $data = $this->account->icontact->requestData($uri, 'POST', $xml_obj->asXML());
      if (isset($data->warnings->warning)) {
        drupal_set_message((string)$data->warnings->warning);
        return FALSE;
      }
      $this->init($data->users->user);
      $this->cache = TRUE;
      return TRUE;
    }
  }
}
