<?php
// $Id: icontact_accounts.admin.inc,v 1.1.2.7 2009/08/07 18:42:38 greenskin Exp $

/**
 * iContact accounts administrative section.
 */
function icontact_accounts_list() {
  $icontact = icontact_load();
  return theme('icontact_accounts_list', $icontact->accounts);
}

/**
 * iContact account form.
 */
function icontact_accounts_form(&$form_state, $account = NULL) {
  icontact_accounts_breadcrumb();

  if ($account === NULL) {
    $icontact = icontact_load();
    $account = new iContactAccount($icontact);
  }
  else if (is_array($account)) {
    $icontact = icontact_load();
    $account = new iContactAccount($icontact, $account);
  }

  $form = array();
  $form['account'] = array('#tree' => TRUE);
  if ($account === NULL) {
    _user_password_dynamic_validation();
    $form['account']['userName'] = array(
      '#type' => 'textfield',
      '#title' => t('User name'),
      '#required' => TRUE
    );
    $form['account']['password'] = array(
      '#type' => 'password_confirm',
      '#required' => TRUE
    );
  }
  else {
    $form['account']['accountId'] = array(
      '#type' => 'value',
      '#value' => $account->accountId
    );
  }
  $form['account']['subscriberLimit'] = array(
    '#type' => 'textfield',
    '#title' => t('Subscriber limit'),
    '#default_value' => $account->subscriberLimit,
    '#required' => TRUE
  );
  $form['account']['accountType'] = array(
    '#type' => 'value',
    '#value' => $account->accountType
  );

  $form['account']['firstName'] = array(
    '#type' => 'textfield',
    '#title' => t('First name'),
    '#default_value' => $account->firstName,
    '#required' => TRUE
  );
  $form['account']['lastName'] = array(
    '#type' => 'textfield',
    '#title' => t('Last name'),
    '#default_value' => $account->lastName,
    '#required' => TRUE
  );
  $form['account']['title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => $account->title,
  );
  $form['account']['phone'] = array(
    '#type' => 'textfield',
    '#title' => t('Phone'),
    '#default_value' => $account->phone,
  );
  $form['account']['fax'] = array(
    '#type' => 'textfield',
    '#title' => t('Fax'),
    '#default_value' => $account->fax,
  );
  $form['account']['email'] = array(
    '#type' => 'textfield',
    '#title' => t('Email address'),
    '#default_value' => $account->email,
    '#required' => TRUE
  );
  $form['account']['companyName'] = array(
    '#type' => 'textfield',
    '#title' => t('Company name'),
    '#default_value' => $account->companyName
  );
  $form['account']['street'] = array(
    '#type' => 'textarea',
    '#title' => t('Street address'),
    '#default_value' => $account->street,
    '#rows' => 2
  );
  $form['account']['city'] = array(
    '#type' => 'textfield',
    '#title' => t('City'),
    '#default_value' => $account->city
  );
  $form['account']['state'] = array(
    '#type' => 'textfield',
    '#title' => t('State or Province'),
    '#default_value' => $account->state
  );
  $form['account']['postalCode'] = array(
    '#type' => 'textfield',
    '#title' => t('Postal code'),
    '#default_value' => $account->postalCode
  );
  /*$form['country'] = array(
    '#type' => 'textfield',
    '#title' => t('Country'),
    '#default_value' => ''
  );*/

  $form['account']['billing'] = array(
    '#type' => 'fieldset',
    '#title' => t('Billing'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE
  );
  $form['account']['billing']['billingStreet'] = array(
    '#type' => 'textarea',
    '#title' => t('Street address'),
    '#default_value' => $account->billingStreet,
    '#rows' => 2
  );
  $form['account']['billing']['billingCity'] = array(
    '#type' => 'textfield',
    '#title' => t('City'),
    '#default_value' => $account->billingCity
  );
  $form['account']['billing']['billingState'] = array(
    '#type' => 'textfield',
    '#title' => t('State or Province'),
    '#default_value' => $account->billingState
  );
  $form['account']['billing']['billingPostalCode'] = array(
    '#type' => 'textfield',
    '#title' => t('Postal code'),
    '#default_value' => $account->billingPostalCode
  );
  /*$form['billing']['billingCountry'] = array(
    '#type' => 'textfield',
    '#title' => t('Country'),
    '#default_value' => ''
  );*/
  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  return $form;
}

function icontact_accounts_form_submit($form, &$form_state) {
  $account = $form_state['values']['account'];
  $icontact = icontact_load();

  // Update existing account.
  if (isset($account['accountId']) && $account['accountId'] > 0) {
    $xml_txt = '<account></account>';
    $xml_obj = simplexml_load_string($xml_txt);
    foreach ($account as $key => $value) {
      if ($key == 'billing') {
        foreach ($value as $k => $v) {
          $xml_obj->addChild($k, $v);
        }
      }
      else if ($key != 'accountId') {
        $xml_obj->addChild($key, $value);
      }
    }
    $data = $icontact->requestData('/a/'. $account['accountId'], 'POST', $xml_obj->asXML());
    if (isset($data->warnings->warning)) {
      drupal_set_message((string)$data->warnings->warning, 'warning');
    }
    else {
      drupal_set_message(t('Account updated'));
    }
  }
  else {
    $xml_txt = '<accounts><account></account></accounts>';
    $xml_obj = simplexml_load_string($xml_txt);
    foreach ($account as $key => $value) {
      if ($key == 'billing') {
        foreach ($value as $k => $v) {
          $xml_obj->account->addChild($k, $v);
        }
      }
      else {
        $xml_obj->account->addChild($key, $value);
      }
    }
    $data = $icontact->requestData('/a/', 'POST', $xml_obj->asXML());
    if (isset($data->warnings->warning)) {
      drupal_set_message((string)$data->warnings->warning, 'warning');
    }
    else {
      drupal_set_message(t('Account saved'));
    }
    $form_state['redirect'] = 'admin/icontact/accounts';
  }
}

/*******************************************************************************
 * Theme Functions
 ******************************************************************************/

function theme_icontact_accounts_list($accounts) {
  $headers = array(
    t('First name'),
    t('Last name'),
    t('Email address'),
    t('Actions')
  );
  $rows = array();
  $actions = array(
    'edit' => array(
      'title' => t('Edit'),
      'href' => '',
      'query' => drupal_get_destination()
    )
  );
  foreach ($accounts as $account) {
    $actions['edit']['href'] = 'admin/icontact/accounts/'. (int)$account->accountId .'/edit';
    if (module_exists('icontact_clientfolders')) {
      $actions['clientfolders'] = array(
        'title' => t('Client folders'),
        'href' => 'admin/icontact/clientfolders',
        'query' => array('accountId' => $account->accountId)
      );
    }
    if (module_exists('icontact_users')) {
      $actions['users'] = array(
        'title' => t('Users'),
        'href' => 'admin/icontact/users',
        'query' => array('accountId' => $account->accountId)
      );
    }
    $row = array(
      array('data' => (string)$account->firstName),
      array('data' => (string)$account->lastName),
      array('data' => (string)$account->email),
      array('data' => theme('links', $actions))
    );
    $rows[] = array('data' => $row);
  }

  $output = '<div>'. theme('table', $headers, $rows) .'</div>';
  return $output;
}
