<?php
// $Id: icontact_subscribe.admin.inc,v 1.1.2.1 2009/08/07 18:42:39 greenskin Exp $

/*******************************************************************************
 * Callback Functions, Forms, and Tables
 ******************************************************************************/

function icontact_subscribe_settings(&$form_state) {
  $form = array();
  $icontact = icontact_load();

  $lists = $options = array();
  foreach ($icontact->accounts as $account) {
    foreach ($account->clientFolders as $clientFolder) {
      foreach ($clientFolder->lists as $list) {
        $lists[$list->listId] = array('accountId' => $account->accountId, 'clientFolderId' => $clientFolder->clientFolderId, 'listId' => $list->listId);
        $options[$list->listId] = $list->name;
      }
    }
  }
  $default_value = array();
  foreach (variable_get('icontact_subscribe_blocks', array()) as $list) {
    $default_value[$list['listId']] = $list['listId'];
  }
  $form_state['lists'] = $lists;
  $form['icontact_subscribe_blocks'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Subscribe blocks'),
    '#description' => t('Choose which lists to provide a subscribe block for.'),
    '#default_value' => $default_value,
    '#options' => $options
  );

  $form['#submit'][] = '_icontact_subscribe_settings_submit';
  return system_settings_form($form);
}

function icontact_subscribe_settings_validate($form, &$form_state) {
  $blocks = array();
  foreach ($form_state['values']['icontact_subscribe_blocks'] as $key => $list) {
    $blocks[$key] = ($list) ? $form_state['lists'][$key] : $list;
  }
  form_set_value($form['icontact_subscribe_blocks'], $blocks, $form_state);
}

function _icontact_subscribe_settings_submit($form, &$form_state) {
  $settings = array();
  $old_settings = variable_get('icontact_subscribe_block_settings', array());
  foreach ($form_state['values']['icontact_subscribe_blocks'] as $key => $list) {
    if (!is_array($list) || empty($list)) {
      db_query("UPDATE {blocks} SET status = %d WHERE module = '%s' AND delta = %d", 0, 'icontact_subscribe', $key);
    }
    else {
      db_query("UPDATE {blocks} SET status = %d WHERE module = '%s' AND delta = %d", 1, 'icontact_subscribe', $key);
    }
  }
}
