if (Drupal.jsEnabled) {
  $(document).ready(function() {
    
  });
  
  function icontactSubscribe(subscribeForm) {
    var fields = new Object;
    $.each(subscribeForm, function(i, n) {
      if (this.name != 'op' && this.name != 'form_token' && this.name != 'form_id') {
        fields[this.name] = this.value;
      }
    });
    
    icontactSubscribePrepare(fields);
  }
  
  function icontactSubscribePrepare(fields) {
    if ($("#icontact_subscribe_result").css("display") != 'none') {
      if ($("#icontact_subscribe_result").html() == '') {
        icontactSubscribeValidate(fields);
      } else {
        $("#icontact_subscribe_result").animate({
          height: 'hide',
          opacity: 'hide'
        },function(){
          $("#icontact_subscribe_result").empty().append('<ul>');
          icontactSubscribeValidate(fields);
        });
      }
    } else {
      icontactSubscribeValidate(fields);
    }
  }
  
  function icontactSubscribeValidate(fields) {
    var errors = 0;
    var field = null;
    
    for (var i in fields) {
      var reg = /required/;
      if (reg.test($("#edit-" + i).attr('class')) == true) {
        if (fields[i] == '') {
          $("#edit-" + i).addClass("error");
          if (errors == 0) {
            $("#icontact_subscribe_result").append('<li>Please enter in the required fields.</li>');
          }
          errors = 1;
        } else {
          $("#edit-" + i).removeClass("error");
        }
      }
    }
    if (fields['email'] != '') {
      var reg = /^([A-Za-z0-9_\-\.+])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
      if(reg.test(fields.email) == false) {
        errors = 1;
        $("#icontact_subscribe_result").append('<li>Invalid Email Address</li>');
        $("#edit-email").addClass("error");
      } else {
        $("#edit-email").removeClass("error");
      }
    }
    $("#icontact_subscribe_result").append('</ul>');
    if ($("#icontact_subscribe_result").html() != '<ul></ul>') {
      $("#icontact_subscribe_result").animate({
        height: 'show',
        opacity: 'show'
      });
    }
    if (errors == 0) {
      icontactSubscribeProcess(fields);
    }
  }
  
  function icontactSubscribeProcess(fields) {
    icontactSubscribeStart();
    
    $.post('/icontact/subscribe',fields,function(data) {
      if (data == 'error') {
        icontactSubscribeFinish('error');
      } else {
        icontactSubscribeFinish(data);
      }
    });
  }
  
  function icontactSubscribeStart() {
    $("#icontact_subscribe_form").animate({
      height: 'hide',
      opacity: 'hide'
    });
    $("#icontact_subscribe_loader").animate({
      height: 'show',
      opacity: 'show'
    });
  }
  
  function icontactSubscribeFinish(status) {
    if (status == 'error') {
      $("#icontact_subscribe_form").animate({
        height: 'show',
        opacity: 'show'
      });
      $("#icontact_subscribe_loader").animate({
        height: 'hide',
        opacity: 'hide'
      });
      $("#icontact_subscribe_result").empty().append('There was an error processing your request. Please try again. If the problem persists, try again later.');
      $("#icontact_subscribe_result").animate({
        height: 'show',
        opacity: 'show'
      });
    } else {
      $("#icontact_subscribe_loader").animate({
        height: 'hide',
        opacity: 'hide'
      });
      $("#icontact_subscribe_result").hide();
      $("#icontact_subscribe_result").empty().append(status + " <a href='' onclick='icontactSubscribeRestart(); return false;'>Return</a>");
      $("#icontact_subscribe_result").animate({
        height: 'show',
        opacity: 'show'
      });
    }
  }
  
  function icontactSubscribeRestart() {
    $("#icontact_subscribe_form").animate({
      height: 'show',
      opacity: 'show'
    });
    $("#icontact_subscribe_result").animate({
      height: 'hide',
      opacity: 'hide'
    },function() {
      $("#icontact_subscribe_result").empty();
    });
  }
}