<?php
// $Id: icontact_ui.menu.inc,v 1.1.2.3 2009/08/21 23:33:15 greenskin Exp $

function icontact_ui_accounts_menu_items() {
  $items = array();
  $items['admin/icontact/accounts'] = array(
    'title' => 'Accounts',
    'description' => 'Manage iContact accounts.',
    'page callback' => 'icontact_ui_accounts_list',
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact accounts'),
    'file' => 'includes/icontact_ui.accounts.inc',
    'type' => MENU_LOCAL_TASK
  );
  $items['admin/icontact/accounts/list'] = array(
    'title' => 'List',
    'description' => 'List iContact accounts.',
    'page callback' => 'icontact_ui_accounts_list',
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact accounts'),
    'file' => 'includes/icontact_ui.accounts.inc',
    'type' => MENU_DEFAULT_LOCAL_TASK,
    'weight' => -10
  );
  /*$items['admin/icontact/accounts/add'] = array(
    'title' => 'Add account',
    'description' => 'Add an iContact account.',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_accounts_form'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact accounts'),
    'file' => 'includes/icontact_ui.accounts.inc',
    'type' => MENU_LOCAL_TASK
  );*/
  $items['admin/icontact/accounts/%icontact_resource/edit'] = array(
    'title' => 'Account',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_accounts_form', 3),
    'load arguments' => array('account'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact accounts'),
    'file' => 'includes/icontact_ui.accounts.inc',
    'type' => MENU_CALLBACK
  );
  return $items;
}

function icontact_ui_clientfolders_menu_items() {
  $items = array();
  $items['admin/icontact/clientfolders'] = array(
    'title' => 'Client folders',
    'description' => 'Manage iContact client folders.',
    'page callback' => 'icontact_ui_clientfolders_list',
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact client folders'),
    'file' => 'includes/icontact_ui.clientfolders.inc',
    'type' => MENU_CALLBACK
  );
  /*$items['admin/icontact/clientfolders/add'] = array(
    'title' => 'Add client folder',
    'description' => 'Add an iContact client folders.',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_clientfolders_form'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact client folders'),
    'file' => 'includes/icontact_ui.clientfolders.inc',
    'type' => MENU_CALLBACK
  );*/
  $items['admin/icontact/clientfolders/%icontact_resource/edit'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_clientfolders_form', 3),
    'load arguments' => array('clientFolder'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact client folders'),
    'file' => 'includes/icontact_ui.clientfolders.inc',
    'type' => MENU_CALLBACK
  );
  return $items;
}

function icontact_ui_contacts_menu_items() {
  $items = array();
  $items['admin/icontact/contacts'] = array(
    'title' => 'Contacts',
    'description' => 'Manage iContact contacts.',
    'page callback' => 'icontact_ui_contacts_list',
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact contacts'),
    'file' => 'includes/icontact_ui.contacts.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/contacts/add/%icontact_resource'] = array(
    'title' => 'Add contact',
    'description' => 'Add an iContact contact.',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_contacts_form', 4),
    'load arguments' => array('clientFolder'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact contacts'),
    'file' => 'includes/icontact_ui.contacts.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/contacts/%icontact_resource/edit'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_contacts_form', 3),
    'load arguments' => array('contact'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact contacts'),
    'file' => 'includes/icontact_ui.contacts.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/contacts/%icontact_resource/history'] = array(
    'title' => 'Contact history',
    'page callback' => 'icontact_ui_contacts_history',
    'page arguments' => array(3),
    'load arguments' => array('contact'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('view iContact contact history'),
    'file' => 'includes/icontact_ui.contacts.inc',
    'type' => MENU_CALLBACK
  );
  return $items;
}

function icontact_ui_lists_menu_items() {
  $items = array();
  $items['admin/icontact/lists'] = array(
    'title' => 'Lists',
    'description' => 'Manage iContact lists.',
    'page callback' => 'icontact_ui_lists_list',
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact lists'),
    'file' => 'includes/icontact_ui.lists.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/lists/add/%icontact_resource'] = array(
    'title' => 'Add list',
    'description' => 'Add an iContact list.',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_lists_form', 4),
    'load arguments' => array('clientFolder'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact lists'),
    'file' => 'includes/icontact_ui.lists.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/lists/%icontact_resource/view'] = array(
    'title' => 'List contacts',
    'page callback' => 'icontact_ui_lists_view',
    'page arguments' => array(3),
    'load arguments' => array('list'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact lists'),
    'file' => 'includes/icontact_ui.lists.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/lists/%icontact_resource/edit'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_lists_form', 3),
    'load arguments' => array('list'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact lists'),
    'file' => 'includes/icontact_ui.lists.inc',
    'type' => MENU_CALLBACK
  );
  return $items;
}

function icontact_ui_messages_menu_items() {
  $items = array();
  $items['admin/icontact/messages'] = array(
    'title' => 'Messages',
    'description' => 'Manage iContact messages.',
    'page callback' => 'icontact_ui_messages_list',
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact messages'),
    'file' => 'includes/icontact_ui.messages.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/messages/add/%icontact_resource'] = array(
    'title' => 'Add message',
    'description' => 'Add an iContact message.',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_messages_form', 4),
    'load arguments' => array('clientFolder'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact messages'),
    'file' => 'includes/icontact_ui.messages.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/messages/%icontact_resource/edit'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_messages_form', 3),
    'load arguments' => array('message'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact messages'),
    'file' => 'includes/icontact_ui.messages.inc',
    'type' => MENU_CALLBACK
  );
  $items['admin/icontact/messages/%icontact_resource/delete'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('icontact_ui_messages_delete_form', 3),
    'load arguments' => array('message'),
    'access callback' => 'icontact_admin_perm',
    'access arguments' => array('manage iContact messages'),
    'file' => 'includes/icontact_ui.messages.inc',
    'type' => MENU_CALLBACK
  );
  return $items;
}
