<?php
// $Id: icontact_users.admin.inc,v 1.1.2.1 2009/08/07 18:42:39 greenskin Exp $

function icontact_users_list() {
  $icontact = icontact_load();
  if (isset($_GET['accountId']) && $_GET['accountId'] > 0 && isset($icontact->accounts[$_GET['accountId']])) {
    // $add = '<div>'. l(t('Add user'), 'admin/icontact/users/add/'. $_GET['accountId']) .'</div>';
    return theme('icontact_users_list', $icontact->accounts[$_GET['accountId']]->users);
  }
  drupal_not_found();
}

function icontact_users_form(&$form_state, $user) {
  _user_password_dynamic_validation();

  if (get_class($user) == 'iContactAccount') {
    $user = new iContactUser($user);
  }

  icontact_users_breadcrumb($user->account->accountId);

  if (is_array($user)) $user = (object)$user;

  $form_state['user'] = $user;
  $form = array('user' => array('#tree' => TRUE));
  if (isset($user->userId) && $user->userId > 0) {
    $form['user']['userId'] = array(
      '#type' => 'hidden',
      '#value' => $user->userId
    );
  }
  else {
    $form['user']['userName'] = array(
      '#type' => 'textfield',
      '#title' => t('User name'),
      '#required' => TRUE
    );
    $form['user']['password'] = array(
      '#type' => 'password_confirm',
      '#required' => TRUE,
      '#size' => 25
    );
  }
  $form['user']['firstName'] = array(
    '#type' => 'textfield',
    '#title' => t('First name'),
    '#default_value' => $user->firstName
  );
  $form['user']['lastName'] = array(
    '#type' => 'textfield',
    '#title' => t('Last name'),
    '#default_value' => $user->lastName
  );
  $form['user']['enabled'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enabled'),
    '#default_value' => $user->enabled
  );
  $form['user']['editor'] = array(
    '#type' => 'select',
    '#title' => t('Editor'),
    '#default_value' => $user->editor,
    '#options' => array(
      2 => t('No editor'),
      3 => t('Recommended'),
      4 => t('Advanced')
    )
  );
  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  return $form;
}

function icontact_users_form_submit($form, &$form_state) {
  $user = $form_state['user'];

  if ($result = $user->save($form_state['values']['user'])) {
    if (isset($form_state['values']['user']['userId']) && $form_state['values']['user']['userId'] > 0) {
      drupal_set_message(t('User successfully updated.'));
    }
    else {
      drupal_set_message(t('User successfully added.'));
      $form_state['redirect'] = array('admin/icontact/users', array('accountId' => $user->account->accountId));
    }
  }
}

/*******************************************************************************
 * Theme Functions
 ******************************************************************************/

function theme_icontact_users_list($users) {
  icontact_accounts_breadcrumb();

  $headers = array(
    t('First name'),
    t('Last name'),
    t('Actions')
  );
  $rows = array();
  $actions = array(
    'edit' => array(
      'title' => t('Edit'),
      'href' => '',
      'query' => drupal_get_destination()
    )
  );
  foreach ($users as $user) {
    $actions['edit']['href'] = 'admin/icontact/users/'. $user->userId .'/edit';
    $row = array(
      array('data' => (string)$user->firstName),
      array('data' => (string)$user->lastName),
      array('data' => theme('links', $actions))
    );
    $rows[] = array('data' => $row);
  }

  $output = '<div>'. theme('table', $headers, $rows) .'</div>';
  return $output;
}
